\ vocabulary display
\ display definitions


require xy-high-level.txt

Variable t-color $FF00FF t-color !

25 Value max-colors

Create color-tab max-colors 1 + cells allot
0 color-tab !

: color-out-of-mem? ( n -- n )
    dup max-colors >
    IF drop ." Farbtabelle ist voll!" quit THEN
;


: #colors ( -- n )
    color-tab @
;

: color-addr ( i -- addr )
    color-out-of-mem?
    1+ cells color-tab +
;


: >color-tab ( rgba i -- )
    #colors 1+ mod            \ just to be save
    color-addr !
    1 color-tab +!
;

: color-tab> ( i -- rgba )
    color-addr @
;

: color! ( i -- )
    color-tab> t-color ! ; 

: rgb>rgba ( rgb -- rgb>rgba )
    8 lshift $FF +  
;

: rgb: ( name ) ( rgb -- )
    rgb>rgba 
    Create
    color-tab @ 
    max-colors >=
    IF drop ." Farbtabelle ist voll!" quit THEN
    color-tab @ dup color-addr ,
    >color-tab 
  does> @ @  t-color !
;


$000000 rgb: black      \ 0
$800000 rgb: maroon     \ 1
$00FF00 rgb: green      \ 2
$808000 rgb: olive      \ 3
$000080 rgb: navy       \ 4
$800080 rgb: purple     \ 5
$008080 rgb: teal       \ 6
$a9a9a9 rgb: darkgray   \ 7 
$C0C0C0 rgb: silver     \ 8
$ff0000 rgb: red        \ 9
$00FF00 rgb: lime       \ 10 
$228B22 rgb: forestgreen \ 11
$FFFF00 rgb: yellow      \ 12
$0000FF rgb: blue        \ 13 
$FF00FF rgb: fuchsia     \ 14
$00FFFF rgb: aqua        \ 15
$FFFFFF rgb: white       \ 16 

color-tab 100 dump
black maroon green olive navy 



\ tex: memimage

\  256 Value mem-w
\  512 Value mem-h

\ mem-w mem-h * sfloats Value mem-size
\ mem-size allocate throw Value mem-buf

: pixel! ( x y -- )
    t-color @ -rot 
    mem-w * +         \ index in membuf 
    sfloats           \ 4 bytes per item
    mem-buf +         \ address in membuffer
    be-l!             \ store
;

: update-memimage ( -- )
    memimage mem-buf mem-w mem-h rgba-texture mipmap +sync ;


: (h-line) ( x y length -- )
    0 ?DO
        over I + over pixel!
    LOOP
    2drop  \  update-memimage
;

: (s-line) ( x y length -- )
    0 ?DO
        2dup I + pixel!
    LOOP
    2drop \  update-memimage
;


\ : square ( x y a -- )
\     >r
\     2dup r@ (h-line)
\     2dup r@ (s-line)
\     2dup r@ + r@ (h-line)
\     swap r@ + swap r> (s-line)
\ ;

\ : squares ( -- )
\     3 0 DO  \ seltsam transparent aber sichtbar?
\         $FF00 I 8 * lshift cr dup 10 hex.r to t-color
\         20 I 8 * + 40 I 8 * + 60 square
\     LOOP
\     cr cr
\     3 0 DO \ silide 
\         $FF00 I 8 * lshift $FF + cr dup  10 hex.r to t-color
\         80 I 8 * + 200 I 8 * + 60 square
\     LOOP
\ ;


: (filled-rectangle) ( x y width height -- )
\ cr ." (filled) "    3 pick . 2 pick . 1 pick . 0 pick . 
    0 ?DO
        2 pick 2 pick I + 2 pick (h-line)
    LOOP
    drop 2drop
;

: tex-empty ( -- ) \ clears the texture
    white
    0 0 mem-w mem-h (filled-rectangle)
;
    

\ ---------------------------- tft-basics ----------------



 Variable tft-width 180 tft-width !
 Variable tft-height 80 tft-height !
Variable orientation -1 orientation !
3 Value tft-pixelsize
0 Value x-offset
0 Value y-offset


: tft>real ( n -- n )
    tft-pixelsize * ; 

: 2tft>real ( n n -- n n )
    tft-pixelsize * swap
    tft-pixelsize * swap
;

: 4tft>real ( n n n n -- n n n n )
    2tft>real 2swap
    2tft>real 2swap
;

: iks ( n -- n )
    tft>real x-offset +
;

: yps ( n -- n )
    tft>real y-offset +
;

: offsets! ( -- )
    mem-w tft-width @ tft-pixelsize * - 2/ to x-offset
    mem-h tft-height @ tft-pixelsize * - 2/ to y-offset
;

: b| ( x y -- )  \ border perpendicular side
    tft-pixelsize 2 * dup 2 *
    tft-height @ tft>real +
    (filled-rectangle)
;

: b_ ( x y -- ) \ border horizontl side
    tft-pixelsize 2 * dup 2 * 
    tft-width @  tft>real +
    swap
    (filled-rectangle)
;

    

\ **** Ach - border muss nach außen gehen!!!    

: tft-border ( -- ) \ make active reagion visible by drawing a border
    -2 iks -2 yps b_
    -2 iks -2 yps b| 
    tft-width @ iks -2 yps b| 
    -2 iks tft-height @ yps b_    
;

: orientation-landscape ( -- )
    160 tft-width !
    80 tft-height !
    true orientation !
    offsets!
    tex-empty
    silver tft-border
    update-memimage
;    


: orientation-portrait ( -- )
    80 tft-width !
    160 tft-height !
    false orientation !
    offsets!
    tex-empty
    silver tft-border
    update-memimage
;    

: landscape ( -- )
\    $78 madctl  \ %01111000
    orientation-landscape
;

orientation-landscape
\ landscape

: landscape-bottom-up
\    $a8 madctl
    orientation-landscape
;

: portrait
\    $C8 madctl
    orientation-portrait
;

: portrait-bottom-up
\    $18 madctl
    orientation-portrait
;

: mirror-v ( -- ) ;

: mirror-h ( -- ) ;


0 Value shape-x
0 Value shape-x'
0 Value shape-width
0 Value shape-y
0 Value shape-y'
0 Value shape-height
0 Value shape-counter

: write-memory ( -- )
    0 to shape-counter
;

: 2bytes>tft ( n -- )
    drop
    shape-counter shape-width 1+ /mod 
    swap
    tft-pixelsize * shape-x iks +
    swap
    tft-pixelsize * shape-y yps +
    tft-pixelsize dup
    (filled-rectangle)
    shape-counter 1+
    shape-height 1+ shape-width 1+ * 1- min
    to shape-counter
;


: set-shape ( x y x' y' -- )
    to shape-y'
    to shape-x'
    to shape-y
    to shape-x
    shape-x' shape-x - abs to shape-width 
    shape-y' shape-y - abs to shape-height   

;

: .shape ( -- )
    ."   x=" shape-x .
    ."   y=" shape-y .
    ."   x'=" shape-x' .
    ."   y'=" shape-y' .
    ."   width=" shape-width .
    ."   height=" shape-height .
;

: tft-fill ( width height -- )
    write-memory
    abs 1 + swap abs 1 + * 0 ?DO t-color @ 2bytes>tft LOOP
    update-memimage
;

\ : tft-fill ( width height -- )
\     2drop
\ \    .shape
\         shape-x iks \ tft-pixelsize *  \ x 
\         shape-y yps \ tft-pixelsize *  \ y'
\         shape-width 1+ tft-pixelsize *  \ width
\         shape-height 1+ tft-pixelsize * \ height
\         (filled-rectangle)
\ ;



: filled-rectangle ( x y width height -- )
    2tuck
    -1 -1 xy+
    xywh+
    set-shape
    write-memory
    tft-fill
;


: tft-clear ( -- )
    0 0 tft-width @ tft-height @
    filled-rectangle
;



: img-fill ( -- )
      0 0 mem-w mem-h (filled-rectangle)
;

: color-demo ( -- )
    #colors
    0 DO \ key . 
        I color!                  \ farbe
        tft-width @ #colors /
        dup I * swap
        0 swap
        tft-height @
        filled-rectangle
    LOOP
    tft-width @ dup #colors mod dup >r
    - ( x ) 0 ( y ) r> ( width ) tft-height @ ( y )
    black filled-rectangle 
;



\ fakes for compability with mecrisp-code


: h@ ( addr -- n )
    w@
;

: Variable ( n / name --)
    Create ,
;

: 2Variable
    Create , ,
;


: color ( -- addr )
    t-color
;
: compiletoflash ( -- ) ;
: 1-foldable ;
: 2+ 2 + ;
: not ( n -- n ) invert $ffffffff and ;
: clz ( n -- b ) \ counts leading zeros in n
    $FFFFFFFF and        \ only 32 bit
    dup 0=
    IF drop 32
    ELSE 31 swap
        BEGIN
            1 rshift dup
            0<>
        WHILE
                swap 1 - swap
        REPEAT
        drop 
    THEN
;


: .koor (  n n n n -- n n n n )
   3 pick . 2 pick . 1 pick . 0 pick .
;


include tft-graphics.txt

: h, ( n -- )
    w,
;
include Lat15-Terminus32x16.mfnt
include mecrisp-fonts.txt
include tft-fonts.txt
include manhattan.fs
include tft-bmp.fs
include turtle.fs

: full-test ( -- )
    landscape 
;
