\ Presentation on ΜΙΝΩΣ2 made in ΜΙΝΩΣ2

\ Author: Bernd Paysan
\ Copyright (C) 2018 Bernd Paysan

\ This program is free software: you can redistribute it and/or modify
\ it under the terms of the GNU Affero General Public License as published by
\ the Free Software Foundation, either version 3 of the License, or
\ (at your option) any later version.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU Affero General Public License for more details.

\ You should have received a copy of the GNU Affero General Public License
\ along with this program.  If not, see <http://www.gnu.org/licenses/>.

require minos2/widgets.fs

[IFDEF] android
    also jni hidekb also android >changed hidestatus >changed previous previous
[THEN]

also minos

ctx 0= [IF]  window-init  [THEN]

require minos2/font-style.fs

44e update-size#

require minos2/text-style.fs
require minos2/presentation-support.fs

tex: minos2
"display.png" file-status 0= [IF] drop
    ' minos2 "display.png" 0.666e }}image-file Constant minos2-glue drop
[ELSE]
    ' minos2 "minos2/net2o-minos2.png" 0.666e }}image-file Constant minos2-glue drop
[THEN]

: logo-img ( xt xt -- o o-img ) 2>r
    baseline# 0e to baseline#
    {{ 2r> }}image-tex dup >r /right
    glue*l }}glue
    }}v >o font-size# f2/ to border o o>
    to baseline# r> ;

' }}i18n-text is }}text'

{{
{{ glue-left @ }}glue

    \ page 0


    
{{
    $000000FF $FFFFFFFF pres-frame    cr  ." pres-frame0 :" ...
    {{
        glue*l }}glue \ ) $CCDDDD3F color, 4e }}frame dup .button1
        l" Emulator" /title
        l" für das Display des Longan Nano von Sipeed" /subtitle
        glue*2 }}glue
        l" MB" /author
        l" April 2020" /location
        \skip
        {{ "➡" }}text }}h  /right
\        {{ "⬅➡" }}text }}h 25%b  /right        
        glue*l }}glue \ ) $CCDDDD3F color, 4e }}frame dup .button1
    }}v box[] >o font-size# to border o Value title-page o o>
}}z box[] dup >slides


\ page 2



tex: memimage

 512 Value mem-w
 512 Value mem-h

mem-w mem-h * sfloats Value mem-size
mem-size allocate throw Value mem-buf



include display-emul.fs

full-test




glue new >o
mem-w 2* s>f hglue-c df!
mem-h 2* s>f vglue-c df!
o o> Constant memimage-glue


{{
    $000000FF $FFFFFFFF pres-frame    cr  ." pres-frame1 :" ...
    {{
        glue*l }}glue
        {{
            glue*l }}glue
            memimage-glue ' memimage white# }}image

            \ {{ "➡" }}text }}h /right
            \     {{ }}glue
            \     {{ "⬅" }}text }}h /left
 
              glue*l }}glue
        }}h box[]
        glue*l }}glue
            

   
    }}v box[]
     {{ "➡" }}text }}h /right
        {{
        }}h box[]
 {{ "⬅" }}text }}h /left
    }}z box[] /flip dup >slides


\ page 3
{{
    $000000FF $FFFFFFFF pres-frame    cr ." pres-frame2 :" ...
    {{
        l" Links" /title
        vt{{
            l" Matthias Koch "  l" mecrisp-quintus auf SOURCEFORGE" bi\\            
            l" 🔗" l" mecrisp-quintus-0.27a-experimental" bm\\
            [: s" xdg-open https://sourceforge.net/projects/mecrisp/files/mecrisp-quintus-0.27a-experimental.tar.gz/download" system ;] 0 click[]
            \skip
            \skip
            l" Terry Porter " l" Dokumentation zu mecrsip" bi\\
            l" 🔗" l" Mecrisp Stellaris Unofficial 1.0 documentation " bm\\
            [: s" xdg-open https://mecrisp-stellaris-folkdoc.sourceforge.io/#" system ;] 0 click[]
     \       l"  " l" Das ist zwar eine Dokumentationsseite für mecrisp-stellaris, aber nichts destotrotz sehr, sehr hilfreich für die Arbeit mit mecrisp-quintus.!" p\\

            \skip
            \skip
            l" Anton Ertl " l" Gforth 0.7.9 installed via net2o fossil repository" bi\\
            l" Bernd Paysan " l" " bi\\
            l" Jens Wilke et al " l" " bi\\
            l" 🔗" l" https://net2o.de/" bm\\
            [: s" xdg-open https://net2o.de/" system ;] 0 click[]
        }}vt
         {{ "⬅" }}text }}h /left
        glue*l }}glue
    }}v box[] >bdr


}}z box[] /flip dup >slides

' }}text is }}text'

\ end
glue-right @ }}glue
}}h box[]
{{
    ' minos2     minos2-glue logo-img solid-frame
}}z
}}z slide[]
to top-widget
cr ." top-widget: " ...
cr ." Fläche: " mem-w . mem-h . 
also opengl

[IFDEF] writeout-en
    lsids ' .lsids s" ef2018/en" r/w create-file throw
    dup >r outfile-execute r> close-file throw
[THEN]

previous

>presentation-key

\\\
Local Variables:
forth-local-words:
    (
     ("[a-z0-9]+(" immediate (font-lock-comment-face . 1)
      ")" nil comment (font-lock-comment-face . 1))
     (("x\"" "l\"") immediate (font-lock-string-face . 1)
      "[\"\n]" nil string (font-lock-string-face . 1))
    )
forth-local-indent-words:
    (
     (("{{" "vt{{") (0 . 2) (0 . 2) immediate)
     (("}}h" "}}v" "}}z" "}}vp" "}}p" "}}vt") (-2 . 0) (-2 . 0) immediate)
    )
End: